@use 'global.scss';
@use 'mixins.scss';

body {
  /* safari 3d fix */
  transform: translate3d(0px, 0px, 0px);
  -webkit-transform: translate3d(0px, 0px, 0px);
  background-color: global.$dark;
  background-image: url(./../images/png/stars.png);
  background-size: contain;
  display: flex;
  flex-direction: column;

  @include mixins.laptop() {
    background-size: 540px 960px;
    height: 100vh;
  }
}

main {
  /* no scrollbar */
  &::-webkit-scrollbar {
    display: none;
  }

  -ms-overflow-style: none;
  scrollbar-width: none;

  @include mixins.laptop() {
    height: 80vh;
  }
}

/* NAVBAR */

.radial-gradient {
  &--1 {
    @include mixins.radial-gradient(1);
  }
  
  &--2 {
    @include mixins.radial-gradient(2);
  }
  
  &--3 {
    @include mixins.radial-gradient(3);
  }
}

.navbar{
  padding: 1rem 2rem;
  border-bottom: 1px;
  border-bottom-style: solid;
  border-color: rgba(255, 255, 255, 0.3);;
  display: flex;
  align-items: center;
  justify-content: space-between;
  position: sticky;
  top: 0;
  left: 0;
  width: 100%;
  backdrop-filter: blur(1rem);
  background-color: rgba(global.$dark, .2);
  z-index: 999;

  @include mixins.laptop() {
    height: global.$sidebar-height;
    padding: 0;
    backdrop-filter: unset;
    background-color: transparent;
  }

  @include mixins.desktop() {
    height: global.$sidebar-height-desktop;
  }

  &__title {
    display: flex;
    align-items: center;
    height: 100%;
  }

  &__maintitle {
    @include mixins.heading-3();

    @include mixins.laptop() {
      width: global.$sidebar-width;
      height: 100%;
      display: flex;
      align-items: center;
      justify-content: center;
      background-color: rgba(global.$blue, .2);
      border: 1px solid global.$blue;
      @include mixins.glowing(global.$blue);
    }

    @include mixins.desktop() {
      width: global.$sidebar-width-desktop;
    }
  }

  &__subtitle {
    font-size: .8rem;
    margin-left: 1rem;
    
    @include mixins.laptop() {
      margin-left: 2rem;
    }
  }
  &__burger {
    position: relative;
    width: 36px;
    height: 100%;
    display: flex;
    align-items: center;
    justify-content: center;

    @include mixins.laptop() {
      width: global.$sidebar-width;
      border-left: 1px solid rgba(white, .3);
    }

    @include mixins.desktop() {
      width: global.$sidebar-width-desktop;
    }
    
    span {
      height: 2px;
      background-color: white;
      width: 36px;
      left:0;
      z-index: 1000;
      position: relative;
      transition: background-color 0.2s ease-in-out;
      &::after{
        content:'';
        height: 2px;
        background-color: white;
        width: 100%;
        position: absolute;
        transform: translateY(8px);
        left:0;
        transition: transform 0.2s ease-in-out;
      }
      &::before {
        content:'';
        height: 2px;
        background-color: white;
        width: 100%;
        position: absolute;
        transform: translateY(-8px);
        left:0;
        transition: transform 0.2s ease-in-out;
      }

      @include mixins.laptop() {
        display: none;
      }
    }
    &--active {
      & span{
        background-color: transparent;
        &::before{
          transform: translateY(0) rotateZ(45deg);
        }
        &::after{
          transform: translateY(0) rotateZ(-45deg);
        }
      }
      
    }
  }
}

/* MENU */

.menu {
  background-color: global.$dark;
  position: fixed;
  width: 100%;
  height: 100vh;
  top: 0px;
  right: -100%;
  z-index: 10;
  transition: .3s ease-in-out;
  padding: 6rem 0 4rem 0;

  @include mixins.laptop() {
    padding: 0;
  }

  &--open {
    right: 0;
  }

  &__list {
    display: flex;
    height: 100%;
    justify-content: center;
    align-items: center;
    flex-direction: column;
    gap: 2%;

    @include mixins.laptop() {
      gap: 4%;
    }
  }

  &__item {
    width: 6rem;
    position: relative;
    transform-style: preserve-3d;

    &::before {
      content: '';
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      transition: .5s ease-in-out;

      @include mixins.laptop() {
        height: 0;
        opacity: 0;
      }
    }

    &:nth-of-type(1)::before {
      border: 1px solid #00ff85;
      @include mixins.glowing(#00ff85);
    }

    &:nth-of-type(2)::before {
      border: 1px solid global.$pink;
      @include mixins.glowing(global.$pink);
    }

    &:nth-of-type(3)::before {
      border: 1px solid global.$blue;
      @include mixins.glowing(global.$blue);
    }

    &:nth-of-type(4)::before {
      border: 1px solid global.$orange;
      @include mixins.glowing(global.$orange);
    }

    &:hover::before {
      height: 100%;
      opacity: 1;
    }
  }

  &__link {
    padding: 1rem;
    display: flex;
    flex-direction: column;
    align-items: center;
    transform-style: preserve-3d;
    transform: translateZ(.5rem);

    @include mixins.laptop() {
      gap: 1rem;
    }
  }

  &__image {
    width: 3rem;
    height: auto;

    @include mixins.laptop() {
      width: 4rem;
    }

    @include mixins.small-laptop() {
      width: 3rem;
    }
  }

  @include mixins.laptop() {
    background-color: transparent;
    position: absolute;
    top: global.$sidebar-height;
    right: 0;
    width: global.$sidebar-width;
    height: calc(100vh - global.$sidebar-height * 2);
    border-left: 1px solid rgba(white, .3);
  }

  @include mixins.desktop() {
    width: global.$sidebar-width-desktop;
    top: global.$sidebar-height-desktop;
    height: calc(100vh - global.$sidebar-height-desktop * 2);
  }
}

/* BACKGROUND PLANET */

.planet {
  position: absolute;
  top: 10rem;
  left: -70%;
  width: 120%;
  object-fit: contain;
  z-index: -10;
  filter: blur(.3rem);

  @include mixins.laptop() {
    top: 60%;
    left: -15%;
    width: 60%;
    filter: blur(.5rem);
  }
}

/* MAIN */
.main {
  margin: 32px;
  display: flex;
  justify-content: center;
  flex-direction: column;
  &__maintitle {
    font-size: 1.8rem;
    font-family: 'Ailerons';
  }
  &__content {
    width: 100%;
    margin-top: 2rem;
  }

  @include mixins.laptop() {
    margin: 0;
    height: calc(100vh - global.$sidebar-height * 2);
    overflow: auto;
    padding: 6rem calc(global.$sidebar-width + 6rem) 1rem calc(global.$sidebar-width + 6rem);
    justify-content: start;
    position: relative;

    &::before {
      content: '';
      position: fixed;
      top: 0;
      left: 0;
      width: global.$sidebar-width;
      height: 100%;
      border-right: 1px solid rgba(white, .3);
    }
  }

  @include mixins.desktop() {
    padding: 6rem calc(global.$sidebar-width-desktop + 6rem);
    height: calc(100vh - global.$sidebar-height-desktop * 2);

    &::before {
      width: global.$sidebar-width-desktop;
    }
  }
}

/* FOOTER */
.footer {
  text-align: center;
  padding: 10px;
  border-top: 1px;
  border-top-style: solid;
  border-top-color: rgba(255, 255, 255, 0.3);;
  display: flex;
  flex-direction: column;
  margin-top: auto;

  &__link {
    margin: 10px;
    font-size: 0.8rem;
  }

  @include mixins.laptop() {
    height: global.$sidebar-height;
    padding: 0 calc(global.$sidebar-width + 4rem);
    position: relative;
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: space-between;

    &::before, &::after {
      content: '';
      position: absolute;
      top: 0;
      width: global.$sidebar-width;
      height: 100%;
    }

    &::before {
      left: 0;
      border-right: 1px solid rgba(white, .3);
    }

    &::after {
      right: 0;
      background-color: rgba(global.$orange, .2);
      border: 1px solid global.$orange;
      transform: translateX(2px);
      @include mixins.glowing(global.$orange);
    }
  }

  @include mixins.desktop() {
    height: global.$sidebar-height-desktop;
    padding: 0 calc(global.$sidebar-width-desktop + 4rem);

    &::before, &::after {
      width: global.$sidebar-width-desktop;
    }
  }
}

/* Loader */

@keyframes gauge {
  0% {
    width: 0;
  }
  100% {
    width: 100%;
  }
}

@keyframes disappear {
  0% {
    opacity: 1;
  }
  70% {
    opacity: 1;
  }
  76% {
    opacity: 0;
  }
  82% {
    opacity: 1;
  }
  88% {
    opacity: 0;
  }
  94% {
    opacity: 1;
  }
  100% {
    opacity: 0;
  }
}

.loader {
  width: 100vw;
  height: 100vh;
  position: absolute;
  top: 0;
  left: 0;
  z-index: 999;
  display: flex;
  gap: 1rem;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  opacity: 0;
  pointer-events: none;
  animation: disappear 1s;

  &__text {
    color: white;
  }

  &__gauge {
    width: 100%;
    max-width: 12rem;
    height: 10px;
    border: 1px solid global.$pink;
    position: relative;

    &::before {
      content: '';
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background-color: global.$pink;
      animation: gauge .5s cubic-bezier(0, .5, 1, 0);
    }

    &.full::before {
      width: 100%;
    }
  }
}

/* Animation */

@keyframes appear {
  0% {
    opacity: 0;
  }
  50% {
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}

.navbar, .menu, .main, .footer {
  animation: appear 1s ease-in-out;
}
